package logging

import (
	`log/syslog`
	`os`

	`r00t2.io/goutils/types`
)

const (
	devlog string = "/dev/log"
	logPerm os.FileMode = 0600
	logPrefix string = "GOLANG PROGRAM"
	appendFlags int = os.O_APPEND|os.O_CREATE|os.O_WRONLY
	syslogFacility syslog.Priority = syslog.LOG_USER
)

// Flags for logger configuration
const (
	LogUndefined types.MaskBit = 1 << iota
	LogJournald
	LogSyslog
	LogFile
	LogStdout
)

var (
	defLogPaths = []string{"/var/log/golang/program.log", "~/.local/log/golang/program.log"}
)
